VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5580
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8310
   LinkTopic       =   "Form1"
   ScaleHeight     =   5580
   ScaleWidth      =   8310
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame Frame1 
      Caption         =   "Temperatur"
      Height          =   975
      Left            =   2880
      TabIndex        =   4
      Top             =   3360
      Width           =   2535
      Begin VB.TextBox txtTemp 
         Alignment       =   2  'Zentriert
         BackColor       =   &H80000000&
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   24
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   615
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   2295
      End
   End
   Begin VB.Timer TimerReadTemp 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   960
      Top             =   240
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   615
      Left            =   6120
      TabIndex        =   3
      Top             =   3600
      Width           =   1455
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Ende"
      Height          =   615
      Left            =   3240
      TabIndex        =   2
      Top             =   4680
      Width           =   1935
   End
   Begin VB.ListBox lstStatus 
      Height          =   2985
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   8055
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   615
      Left            =   720
      TabIndex        =   0
      Top             =   3600
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *** Auslesen der Temperatur vom Cypress-USB-Thermometer ***
' //                                                       //
' // Autor: Joachim Bonath (1. Praxissemester 2002)        //
' //                                                       //
' ***********************************************************
'
Option Explicit

'Objekt-Variable vom Typ USBIOCOMLib.USBIOInterface anlegen
Dim WithEvents Device1 As USBIOCOMLib.USBIOInterface
Attribute Device1.VB_VarHelpID = -1


Private Sub Form_Load()
'Beim Laden des Programms folgendes tun:

Dim Status As Long  'Status-Variable
Dim Antwort As Long 'Rckgabewert vom MsgBox-Befehl
Dim Devices As Long 'Variable: Anzahl der gefundenen Gerte

Set Device1 = New USBIOCOMLib.USBIOInterface
'Objekt anlegen. (Device1 ist Pointer auf Objekt)
On Error Resume Next

'Enumeration der verfgbaren Gerte
'Zum Testen: Verwendung der USB-IO Standard GUID
'Wenn man eigene GUID frs Gert hat (GUIDGEN.EXE), dann diese verwenden.
Do
Device1.EnumerateDevices "{325ddf96-938c-11d3-9e34-0080c82727f4}", Devices

  If Devices >= 1 Then
      
      'ffnen des ersten Gertes, das mit dem USBIO-Treiber
      'verbunden ist. (Index 0)
      Device1.OpenDevice 0, Status
         If Status = USBIO_ERR_SUCCESS Then
             lstStatus.AddItem ("USB Device geffnet !")
         Else
             MsgBox "Kann USB-Gert nicht ffnen !"
             End 'Programm-Ende
         End If
  Else
      Dim Mldg, Stil, Titel
      Mldg = "Kein USB-Gert angeschlossen oder Treiber nicht installiert !"
      'Meldung definieren.
      Stil = vbRetryCancel + vbCritical 'Schaltflchen
      Titel = "Fehler beim ffnen des Gerts"  'Titel definieren.
      Antwort = MsgBox(Mldg, Stil, Titel) 'Meldung anzeigen.
         If Antwort = vbCancel Then
           End 'Programm-Ende
         End If
  End If
Loop Until Antwort <> vbRetry 'Schleife luft so lange, bis Gert geffnet
                              'werden kann !

Call DeviceInit 'Gert initialisieren
  
End Sub

Private Sub DeviceInit()

' *** Infos anzeigen ******************************************************
lstStatus.AddItem ("DevicePathName: " & _
                    CStr(Device1.DevicePathName)) 'DevicePathName anzeigen.
lstStatus.AddItem ("Demo-Version (USBIO.SYS) = " & _
                    Device1.IsDemoVersion)  'Demo-Version aktiv ?
lstStatus.AddItem ("Lite-Version (USBIO.SYS) = " & _
                    Device1.IsLightVersion) 'Lite-Version aktiv ?
' *************************************************************************

'Die folgende Sequenz konfiguriert das Gert.
'Es wird einfach angenommen, dass 0 ein gltiges Interface ist.
'Parameter: 0,0,8,Status: Die 8 bezeichnet die max. Transfer-Gre in Byte
'D.h. es knnen bei einem Datentransfer max. 8 Byte auf einmal bertragen
'werden. Diese landen dann im Puffer.
'Standardwert ist 4096
Dim Status As Long 'Status-Variable
                   '(nimmt Rckgabewert, z.B. Fehlercode entgegen)
Device1.AddInterface 0, 0, 8, Status
  ShowError Status 'Eventuelle Fehler anzeigen
  
'Die Konfiguration setzen: 0 ist ok fr einmalig zu konfigurierende Gerte
'Die von AddInterface gesetzten Werte werden hier jetzt aktiviert.
Device1.SetConfiguration 0, Status
  ShowError Status 'Eventuelle Fehler anzeigen

'Device1 an Endpoint 1 (Adresse 0x81) binden.
'Ab jetzt sind Datentransfers mglich.
Device1.Bind Val(&H81), Status
  ShowError Status 'Eventuelle Fehler anzeigen
Device1.ResetPipe Status
  ShowError Status 'Eventuelle Fehler anzeigen

End Sub


Private Sub cmdStart_Click()

TimerReadTemp.Enabled = True 'Timer aktivieren
Form1.cmdStart.Enabled = False 'Start-Button deaktivieren

End Sub

Private Sub cmdStop_Click()

TimerReadTemp.Enabled = False 'Timer stoppen
Form1.cmdStart.Enabled = True 'Start-Button wieder aktivieren

End Sub

Private Sub TimerReadTemp_Timer()
'Dieser Timer wird bentigt, um alle 0,5 sec einen neuen Temperaturwert
'einzulesen und anzuzeigen.

Dim Temperatur As String 'Variable Temperatur wird ByRef bergeben.
Call ReadTemperature(Temperatur) 'Temperatur auslesen.

Dim Vorzeichen As String  'Variable Sign wird ByRef bergeben.
Call ReadSign(Vorzeichen) 'Vorzeichen auslesen.

Dim ButtonPressed As Boolean 'Variable ButtonPressed wird ByRef bergeben
Call ReadButton(ButtonPressed) 'Prfen ob Taster gedrckt wurde

Dim Einheit As String
Einheit = "C" 'Default Einheit ist C
   
   If ButtonPressed = True Then   'Wenn der Taster gedrckt wurde
      Einheit = "F"               'Einheit auf Fahrenheit stellen
      Call ConvertCelsiusToFahrenheit(Temperatur) 'Temperatur von C
   End If                                         'in Fahrenheit konvertieren
   
'Ausgabe der Werte in der Textbox
txtTemp.Text = Vorzeichen & Temperatur & " " & Einheit

End Sub

Private Sub ReadTemperature(ByRef Temperatur As String)

Dim ReadBuffer(7) As Byte 'Lesepuffer (8 Byte)

Dim ByteCount As Long
ByteCount = 8
'Anzahl an Bytes, die gelesen werden sollen.
'Nach dem Datentransfer steht in dieser Variable, wieviele Bytes
'tatschlich in den Lesepuffer eingegangen sind !

Dim Request_Read_RAM As Long
Request_Read_RAM = &H2 '(Request-Werte siehe Doku bzw. Thermometer.PDF)

Dim Value As Long
Value = &H33 'Adresswert (Microcontroller), siehe Doku bzw. Thermometer.PDF

Dim Index As Long
Index = 0 'Dieser Wert wird vermutlich an die Adresse geschrieben, die in
          'Value angegeben ist, falls dies mglich bzw. erforderlich ist.
          
Dim Status As Long 'Variable fr Funktionsrckgabewert


'*** Einlesen des aktuellen Temperaturwertes vom Thermometer ***
'ReadBuffer (Lesepuffer. Dieser mu ausreichend gro sein. Hier: 8 Byte)
'ByteCount (siehe oben)
'USBIOCOM_SHORT_TRANSFER_OK = Flag: Wenn Datenpakete kommen, die kleiner als
'                                   MaxTransferSize sind (hier 8 Byte), dann
'                                   keinen Fehler melden !!!
'USBIOCOM_REQUEST_TYPE: USBIOCOM_RequestTypeVendor = 2 (Vendor-Request)
'Recipient: USBIOCOM_RecipientEndpoint = 2 (Endpoint als Empfnger)
'           weitere siehe USBIOCOM.PDF (Thesycon)
'RequestTypeReservedBits = 0 (hat hier keine Funktion)
'Request (siehe oben)
'Value (siehe oben)
'Index (siehe oben)
'Status (Rckgabewert der Funktion: Enthlt bei Fehlern den entspr.
'        Fehlercode)
'****************************************************************
Device1.ClassOrVendorInRequest ReadBuffer, _
                               ByteCount, _
                               USBIOCOM_SHORT_TRANSFER_OK, _
                               USBIOCOM_RequestTypeVendor, _
                               USBIOCOM_RecipientEndpoint, _
                               0, _
                               Request_Read_RAM, _
                               Value, _
                               Index, _
                               Status

  ShowError Status 'Eventuelle Fehler anzeigen.
  
Temperatur = CStr(ReadBuffer(1) / 2)
'Temperaturwert aus dem Puffer auslesen (Byte 1) und umrechnen.
'Umrechnung abgendert.
'Ursprnglicher Befehl war: Temperatur = CStr(((lout \ 256) And 255) / 2)
'Dieser ist aus dem Buch. Allerdings war die dortige Variable lout
'vom Typ Long und enthielt komplett die 3 ersten Bytes im Lesepuffer.
'Daher war eine Extrahierung des Temperaturwertes notwendig.
'Diese entfllt hier.

'Zum Debuggen: Werte anzeigen
'If Status = USBIO_ERR_SUCCESS Then
'    lstStatus.AddItem (ReadBuffer(0) & " *** " & ReadBuffer(1) & " *** " & _
'                       ReadBuffer(2) & " *** " & ReadBuffer(3) & " *** " & _
'                       ReadBuffer(4) & " *** " & ReadBuffer(5) & " *** " & _
'                       ReadBuffer(6) & " *** " & ReadBuffer(7))
'  Else
'    ShowError Status
'  End If
  
End Sub


Private Sub ReadSign(ByRef Sign As String)

Dim ReadBuffer(7) As Byte 'Lesepuffer (8 Byte)

Dim ByteCount As Long
ByteCount = 8
'Anzahl an Bytes, die gelesen werden sollen.
'Nach dem Datentransfer steht in dieser Variable, wieviele Bytes
'tatschlich in den Lesepuffer eingegangen sind !

Dim Request_Read_RAM As Long
Request_Read_RAM = &H2 '(Request-Werte siehe Doku bzw. Thermometer.PDF)

Dim Value As Long
Value = &H34 'Adresswert (Microcontroller), siehe Doku bzw. Thermometer.PDF

Dim Index As Long
Index = 0 'Dieser Wert wird vermutlich an die Adresse geschrieben, die in
          'Value angegeben ist, falls dies mglich bzw. erforderlich ist.
          
Dim Status As Long 'Variable fr Funktionsrckgabewert


'*** Einlesen des Vorzeichens des Temperaturwertes ***
'ReadBuffer (Lesepuffer. Dieser mu ausreichend gro sein. Hier: 8 Byte)
'ByteCount (siehe oben)
'USBIOCOM_SHORT_TRANSFER_OK = Flag: Wenn Datenpakete kommen, die kleiner als
'                                   MaxTransferSize sind (hier 8 Byte), dann
'                                   keinen Fehler melden !!!
'USBIOCOM_REQUEST_TYPE: USBIOCOM_RequestTypeVendor = 2 (Vendor-Request)
'Recipient: USBIOCOM_RecipientEndpoint = 2 (Endpoint als Empfnger)
'           weitere siehe USBIOCOM.PDF (Thesycon)
'RequestTypeReservedBits = 0 (hat hier keine Funktion)
'Request (siehe oben)
'Value (siehe oben)
'Index (siehe oben)
'Status (Rckgabewert der Funktion: Enthlt bei Fehlern den entspr.
'        Fehlercode)
'******************************************************
Device1.ClassOrVendorInRequest ReadBuffer, _
                               ByteCount, _
                               USBIOCOM_SHORT_TRANSFER_OK, _
                               USBIOCOM_RequestTypeVendor, _
                               USBIOCOM_RecipientEndpoint, _
                               0, _
                               Request_Read_RAM, _
                               Value, _
                               Index, _
                               Status

  ShowError Status 'Eventuelle Fehler anzeigen.
  
Sign = CInt(ReadBuffer(1)) 'Vorzeichen aus dem Puffer auslesen (Byte 1)
  If Sign = 0 Then
    Sign = "+"  '(Positives Vorzeichen)
  Else
    Sign = "-"  '(Negatives Vorzeichen)
  End If

'Zum Debuggen: Werte anzeigen
'If Status = USBIO_ERR_SUCCESS Then
'    lstStatus.AddItem (ReadBuffer(0) & " *** " & ReadBuffer(1) & " *** " & _
'                       ReadBuffer(2) & " *** " & ReadBuffer(3) & " *** " & _
'                       ReadBuffer(4) & " *** " & ReadBuffer(5) & " *** " & _
'                       ReadBuffer(6) & " *** " & ReadBuffer(7))
'  Else
'    ShowError Status
'  End If
  
End Sub

Private Sub ReadButton(ByRef ButtonPressed As Boolean)

Dim ReadBuffer(7) As Byte 'Lesepuffer (8 Byte)

Dim ByteCount As Long
ByteCount = 8
'Anzahl an Bytes, die gelesen werden sollen.
'Nach dem Datentransfer steht in dieser Variable, wieviele Bytes
'tatschlich in den Lesepuffer eingegangen sind !

Dim Request_Read_RAM As Long
Request_Read_RAM = &H2 '(Request-Werte siehe Doku bzw. Thermometer.PDF)

Dim Value As Long
Value = &H7A 'Adresswert (Microcontroller), siehe Doku bzw. Thermometer.PDF

Dim Index As Long
Index = 0 'Dieser Wert wird vermutlich an die Adresse geschrieben, die in
          'Value angegeben ist, falls dies mglich bzw. erforderlich ist.
          
Dim Status As Long 'Variable fr Funktionsrckgabewert


'*** Einlesen: Button-Status (Taster C / F) des Thermometers ***
'ReadBuffer (Lesepuffer. Dieser mu ausreichend gro sein. Hier: 8 Byte)
'ByteCount (siehe oben)
'USBIOCOM_SHORT_TRANSFER_OK = Flag: Wenn Datenpakete kommen, die kleiner als
'                                   MaxTransferSize sind (hier 8 Byte), dann
'                                   keinen Fehler melden !!!
'USBIOCOM_REQUEST_TYPE: USBIOCOM_RequestTypeVendor = 2 (Vendor-Request)
'Recipient: USBIOCOM_RecipientEndpoint = 2 (Endpoint als Empfnger)
'           weitere siehe USBIOCOM.PDF (Thesycon)
'RequestTypeReservedBits = 0 (hat hier keine Funktion)
'Request (siehe oben)
'Value (siehe oben)
'Index (siehe oben)
'Status (Rckgabewert der Funktion: Enthlt bei Fehlern den entspr.
'        Fehlercode)
'****************************************************************
Device1.ClassOrVendorInRequest ReadBuffer, _
                               ByteCount, _
                               USBIOCOM_SHORT_TRANSFER_OK, _
                               USBIOCOM_RequestTypeVendor, _
                               USBIOCOM_RecipientEndpoint, _
                               0, _
                               Request_Read_RAM, _
                               Value, _
                               Index, _
                               Status

  ShowError Status 'Eventuelle Fehler anzeigen.
  
'Button-Status auswerten (Byte 1 im Lesepuffer !)
'Power-On-Zustand: Byte 1 = 01h (Taster wurde noch nicht gedrckt)
'Wird der Taster gedrckt, so geht der Wert auf von Byte 1 auf 00h
'Bei erneutem Drcken wieder auf 01h
'(Toggle-Betrieb !)
If ReadBuffer(1) = 0 Then
  ButtonPressed = True
Else
  ButtonPressed = False
End If

'Zum Debuggen: Werte anzeigen
'If Status = USBIO_ERR_SUCCESS Then
'    lstStatus.AddItem (ReadBuffer(0) & " *** " & ReadBuffer(1) & " *** " & _
'                       ReadBuffer(2) & " *** " & ReadBuffer(3) & " *** " & _
'                       ReadBuffer(4) & " *** " & ReadBuffer(5) & " *** " & _
'                       ReadBuffer(6) & " *** " & ReadBuffer(7))
'  Else
'    ShowError Status
'  End If
  
End Sub

Private Sub ConvertCelsiusToFahrenheit(ByRef Temperatur As String)
'Umrechnung von C in Fahrenheit
  
Dim Help As Double 'Hilfsvariable
Dim Help2 As Long  '2. Hilfsvariable
Help = CDbl(Val(Temperatur)) 'String in Double-Wert konvertieren
Help = (Help * 9 / 5) + 32   'Umrechnung von C in Fahrenheit
Help2 = CLng(Help) 'Double Wert in Long-Wert konvertieren

   'Nachkommastellen noch entsprechend auf oder abrunden.
   If (Help - Help2) >= 0.5 Then
      Help2 = Help2 + 1
   End If

Temperatur = CStr(Help2) 'Rckkonvertierung in String durchfhren.
    
End Sub

Private Sub ShowError(ErrorCode As Long) 'Anzeigen von aufgetretenen Fehlern
'Ist der bergebene ErrorCode ungleich USBIO_ERR_SUCCESS dann liegt ein
'Fehler vor. Ansonsten war der Vorgang erfolgreich.

  If ErrorCode <> USBIO_ERR_SUCCESS Then
    lstStatus.AddItem (Device1.ErrorText(ErrorCode)) 'Die USBIOCOMLib
  End If                                             'bernimmt das Anzeigen
  
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

'Vor dem Beenden des Programms: Aufrumen !
Dim Status As Long
Device1.DeleteInterfaces
Device1.UnconfigureDevice Status 'Einstellungen zurcksetzen
  ShowError Status
Device1.CloseDevice              'Gert schlieen.

End Sub

Private Sub cmdExit_Click()
End 'Programm-Ende
End Sub

